找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 1194|回复: 0

[分享] cut a hole in a hatch

[复制链接]

已领礼包: 859个

财富等级: 财运亨通

发表于 2014-6-7 23:56:10 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有账号?立即注册

×
using (Transaction acTrans = acDb.TransactionManager.StartTransaction())
{
       var acBlkTbl = (BlockTable)acTrans.GetObject(acDb.BlockTableId, OpenMode.ForRead);
   var acBlkTblRec = (BlockTableRecord)acTrans.GetObject(acBlkTbl[BlockTableRecord.ModelSpace], OpenMode.ForWrite);
      // Create the rectangle
     var   acPoint = new Point2d(0, 0);
        var acPoly = new Polyline(4);
    acPoly.Normal = Vector3d.ZAxis;
    acPoly.AddVertexAt(0, acPoint, 0, -1, -1);
    acPoly.AddVertexAt(1, new Point2d(acPoint.X + 20, acPoint.Y), 0, -1, -1);
        acPoly.AddVertexAt(2, new Point2d(acPoint.X + 20, acPoint.Y + 20), 0.0, -1.0, -1.0);
    acPoly.AddVertexAt(3, new Point2d(acPoint.X, acPoint.Y + 20), 0.0, -1.0, -1.0);
    acPoly.Closed = true;    // Add the rectangle to the block table record
    acBlkTblRec.AppendEntity(acPoly);
    acTrans.AddNewlyCreatedDBObject(acPoly, true);
       // Create the rectangle hole
    var acHole = new Polyline(4);
    acHole.Normal = Vector3d.ZAxis;
    acPoint = new Point2d(5,5);
    acHole.AddVertexAt(0, acPoint, 0.0, -1.0, -1.0);
    acHole.AddVertexAt(1, new Point2d(acPoint.X + 5, acPoint.Y), 0.0, -1.0, -1.0);
    acHole.AddVertexAt(2, new Point2d(acPoint.X + 5, acPoint.Y + 5), 0.0, -1.0, -1.0);
    acHole.AddVertexAt(3, new Point2d(acPoint.X, acPoint.Y + 5), 0.0, -1.0, -1.0);
    acHole.Closed = true;
       // Add the hole rectangle to the block table record
    acBlkTblRec.AppendEntity(acHole);    acTrans.AddNewlyCreatedDBObject(acHole, true);
       // Create the hatch    var acHatch = new Hatch();
    acBlkTblRec.AppendEntity(acHatch);
       acTrans.AddNewlyCreatedDBObject(acHatch, true);
    acHatch.SetDatabaseDefaults();
    acHatch.SetHatchPattern(HatchPatternType.PreDefined, "ANSI31");
    acHatch.PatternScale = 10;
    acHatch.Associative = true;
       // Add the outer boundary
    acHatch.AppendLoop(HatchLoopTypes.External, new ObjectIdCollection { acPoly.ObjectId });
      // Add the inner boundary
    acHatch.AppendLoop(HatchLoopTypes.Default, new ObjectIdCollection { acHole.ObjectId });
      // Validate the hatch
    acHatch.EvaluateHatch(true);
       acTrans.Commit();
}
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|Archiver|手机版|小黑屋|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )

GMT+8, 2024-5-22 23:52 , Processed in 0.162970 second(s), 27 queries , Gzip On.

Powered by Discuz! X3.5

© 2001-2024 Discuz! Team.

快速回复 返回顶部 返回列表